import pygame, sys, random,time


from datetime import datetime

#Dateinamen der KI
def Name_time(name):
    # datetime object containing current date and time
    now = datetime.now()
    # dd/mm/YY H:M:S
    new_name = str(name) +  "_" + now.strftime("%d-%m-%Y_%H_%M_%S")
    return new_name



##### Visueler part

# WIP, Zeigt Punktestand an
def draw_text(text,screen,y_pos = 5,x_pos = 5):
    font = pygame.font.SysFont("arial", 25)
    for line in text.splitlines():
        for pos in range(1, len(line)+1):
            text = font.render(line[:pos], 1, (255, 255, 255))
            screen.blit(text, (x_pos, y_pos))
            pygame.display.update()
            #time.sleep(0.02)
        y_pos += 25
        x_pos += 0


# Klasse der Linien-Sprites
class Linie(pygame.sprite.Sprite):
    def __init__(self,b,h,x,y,Nummer=[0,0],color=(255,255,255)):
        super().__init__()
        self.image =pygame.Surface([b,h])
        self.image.fill(color)
        self.rect = self.image.get_rect()
        self.rect.topleft = [x,y]
        self.Nummer=Nummer
        self.Color=color
        self.Set=False
    def Update(self):
        self.image.fill(self.Color)
        self.Set=True
        return

# Klasse der Feld-Sprites
class Feld(pygame.sprite.Sprite):
    def __init__(self,b,h,x,y,Nummer=[0,0],color=(255,255,255), Bestizer=0):
        super().__init__()
        self.image =pygame.Surface([b,h])
        self.image.fill(color)
        self.rect = self.image.get_rect()
        self.rect.topleft = [x,y]
        self.Nummer=Nummer
        self.Color=color
        self.Set=False
    def Feld_Update(self,G):
        self.Color=G.Player_color[G.Player+2]
        self.image.fill(self.Color)
        self.Set=True
        return


# --- Initialisierung ---
# - es wird ein Spielfeld mit der Höhe "h" und der Breite "b" erzeugt

# Initialisierung der Linien:
def Init_Linien(start_x,start_y,b,h,dicke,lang,Linien_gruppe):
    for i in range(h):
        for j in range(b):
            neue_linie = Linie(lang, dicke, start_x+(lang+dicke)*j, start_y+(lang+dicke)*i-dicke,[j,i*2])
            Linien_gruppe.add(neue_linie)
            neue_linie = Linie(dicke, lang, start_x+(lang+dicke)*j-dicke, start_y+(lang+dicke)*i,[j,i*2+1])
            Linien_gruppe.add(neue_linie)
        neue_linie = Linie(dicke, lang, start_x+(lang+dicke)*b-dicke, start_y+(lang+dicke)*i,[b,2*i+1])
        Linien_gruppe.add(neue_linie)
    for j in range(b):
        neue_linie = Linie(lang, dicke, start_x+(lang+dicke)*j, start_y+(lang+dicke)*h-dicke,[j,h*2])
        Linien_gruppe.add(neue_linie)

# Initialisierung der Felder:
def Init_Felder(start_x,start_y,b,h,dicke,lang,Feld_gruppe):
    for i in range(h):
        for j in range(b):
            neues_Feld = Feld(lang,lang,start_x+(lang+dicke)*j,start_y+(lang+dicke)*i,[j,i],(0,0,0))
            Feld_gruppe.add(neues_Feld)

# Initialisiert das Spielfeld
def Init_Spiel(start_x,start_y,b,h,dicke,lang,Linien_gruppe,Feld_gruppe):
    Init_Linien(start_x,start_y,b,h,dicke,lang,Linien_gruppe)
    Init_Felder(start_x,start_y,b,h,dicke,lang,Feld_gruppe)

# Es wird eine Zuordnug (als Dictionary) zwischen Linien und Feldern angelegt
def Init_Dict(b,h):
    Dict={}
    for i in range(h):
        for j in range(b):
            Dict[j,i,0]= [j,2*i]
            Dict[j,i,1]= [j+1,2*i+1]
            Dict[j,i,2]= [j,2*i+2]
            Dict[j,i,3]= [j,2*i+1]
    #print(Dict)
    return Dict


# Funktion um den Spielfeldrand zu deaktivieren
def Disable_Edges(b,h,Linien_gruppe,dis_Color=(100,100,100)):
    for i in range(b):
        Linie=Get_Linie(Linien_gruppe, [i,0])
        Linie.Color=dis_Color
        Linie.Update()
        Linie=Get_Linie(Linien_gruppe, [i,h*2])
        Linie.Color=dis_Color
        Linie.Update()
    for i in range(h):
        Linie=Get_Linie(Linien_gruppe, [0,i*2+1])
        Linie.Color=dis_Color
        Linie.Update()
        Linie=Get_Linie(Linien_gruppe, [b,i*2+1])
        Linie.Color=dis_Color
        Linie.Update()

# Felder Deaktivieren/Einfärben
def Diable_Feld(Feld_gruppe, Linien_gruppe, Game, Dict, Nummer,dis_Color_F=(150,150,150),dis_Color_L=(100,100,100)):
    F=Get_Feld(Feld_gruppe, Nummer)
    F.image.fill(dis_Color_F)
    F.Set=True
    Game.Diabled+=1
    for k in range(4):
        L=Dict[Nummer[0],Nummer[1],k]
        Linie=Get_Linie(Linien_gruppe, L)
        Linie.Color=dis_Color_L
        Linie.Update()



# Liefert eine Liste mit den Felder, die eine bestimmten Linie einthalten
def Dict_get(Dict, Nummer):
    f=[]
    for Feld, Linie in Dict.items():
        if Linie == Nummer:
            f.append(Feld)
            #print("Dict: Linie: ",Linie, "  Feld: ", Feld)
    return f

# Liefert das Linien-Objekt mit der gegebenen Nummer zurück
def Get_Linie(Linien_gruppe, Nummer):
    for L in Linien_gruppe:
        if L.Nummer == Nummer:
            return L

# Liefert das Feld-Objekt mit der gegebenen Nummer zurück
def Get_Feld(Feld_gruppe, Nummer):
    for F in Feld_gruppe:
        if F.Nummer == Nummer:
            return F


# Abfrage ob ein bestimmets Feld vollendet ist
def Check_Feld(Dict,Feld, Linien_gruppe):
    Set=[]
    for k in range(4):
        L=Dict[Feld[0],Feld[1],k]
        Linie=Get_Linie(Linien_gruppe, L)
        #print(Linie.Set)
        #print("Check_Feld: ",k, "  ", Linie.Set)
        if Linie.Set==False:
            return False
    return True



# Das Game-Objekt speichert den Spielstand
class Game_Object():
    def __init__(self):
        super().__init__()
        self.Player=0
        self.Player_color=[(100,230,150),(170,100,230),(50,170,100),(100,50,170)]
        self.Player_Punkte=[0,0]
        self.has_changed=False
        self.Counter=1
        self.Data=[]
    def Init_Data(self,b,h):
        for y in range(2*h+1):
            self.Data.append([])
            for x in range(b+1*(y%2)):
                self.Data[y].append(0)
    def Update_Data(self,Linie):
        N=Linie.Nummer
        self.Data[N[1]][N[0]]=int(Linie.Set)

    def Change_Player(self):
        if self.Player==0:
            self.Player=1
        else:
            self.Player=0
    def Set_Linie(self, Nummer, Dict, Linien_gruppe,Feld_gruppe):
        Set_Linie(Linien_gruppe, Nummer)
        Felder=Dict_get(Dict, Nummer)
        C=False
        for Feld in Felder:
            C=Check_Feld(Dict,Feld, Linien_gruppe) or C
            Check=Check_Feld(Dict,Feld, Linien_gruppe)
            if Check:
                F=Get_Feld(Feld_gruppe, [Feld[0],Feld[1]])
                F.Feld_Update(self)
                self.Player_Punkte[self.Player] +=1
                self.has_changed=True
        if not C:
            self.Change_Player()
            return
    def Count_up(self):
        self.Counter+=1
    def Check_Win(self,b,h):
        a=False
        Gewinner=0
        if self.Player_Punkte[0]+self.Player_Punkte[1]==b*h:
            if self.Player_Punkte[0]>self.Player_Punkte[1]:
                Gewinner=1
            else:
                Gewinner=2
            a=True

        Info=[a,Gewinner]
        return Info



###Hauptprogramm
def Main_Spieler_gegen_KI(b, h, net, width = 1280, height = 720, Edges_not_playable=False):

    print("---Spieler gegen KI---")

    G=Game_Object()
    BG_Gruppe=pygame.sprite.Group()
    BG=Init_Felder(0,0,1,1,170,170,BG_Gruppe)


    Linien_gruppe= pygame.sprite.Group()
    Feld_gruppe= pygame.sprite.Group()
    clock = pygame.time.Clock()


    screen = pygame .display. set_mode((width,height))
    Init_Spiel(100,100,b,h,10,100,Linien_gruppe,Feld_gruppe)
    Dict=Init_Dict(b,h)
    if Edges_not_playable:
        Disable_Edges(b,h,Linien_gruppe)
    G.Init_Data(b,h)

    Game_is_running = True

    while Game_is_running:
        if G.Player == 0:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    pygame.quit()
                    sys.exit()
                if event.type == pygame.MOUSEBUTTONDOWN:
                    mouse_pos=pygame.mouse.get_pos()
                    for Linie in Linien_gruppe:
                        if Linie.rect.collidepoint(mouse_pos):
                            print("player: ", G.Player)
                            print(Linie.Nummer)
                            Dict_get(Dict, Linie.Nummer)
                            if not Linie.Set:
                                Linie.Color=G.Player_color[G.Player]
                                G.Set_Linie(Linie.Nummer, Dict, Linien_gruppe,Feld_gruppe)
                                G.Count_up()
                                Linie.Update()
                                G.Update_Data(Linie)
                                print ('yay!')
                    for Feld in Feld_gruppe:
                        if Feld.rect.collidepoint(mouse_pos):
                            print(Feld.Nummer)

        elif G.Player == 1:
            print("player: ", G.Player)
            Spielfeld = tuple(liste_2D_zu_1D(G.Data))

            Output = net.activate(Spielfeld)#funktion für eingabe der KI usw...

            for i in range(len(Output)):
                if Spielfeld[i]==1:
                    Output[i]=-10000


            Eingabe_index = Output.index(max(Output)) + 1
            Eingabe = Koordinaten_berechnen(b,h,Eingabe_index)


            Linie = Get_Linie(Linien_gruppe, Eingabe)

            if Linie.Set:
                print("---Ende nach " + str(G.Counter) + " Zügen.")
                print("KI " + str(G.Player) + " hat ein falsches Feld gewählt")
                print("Die Eingabe war: " , Eingabe, ", Index: ", Eingabe_index, ", Wert: ", max(Output))
                print(G.Data)
                print(Output)
                Game_is_running = False

            Linie.Color=G.Player_color[G.Player]
            G.Set_Linie(Linie.Nummer, Dict, Linien_gruppe,Feld_gruppe)
            G.Count_up()
            Linie.Update()
            G.Update_Data(Linie)

        if G.has_changed:

            print("Spieler 1:  "+str(G.Player_Punkte[0])+"\n"+"Spieler 2:  "+str(G.Player_Punkte[1]))
            G.has_changed=False
            BG_Gruppe.draw(screen)
            draw_text("Spieler 1:  "+str(G.Player_Punkte[0])+"\n"+"Spieler 2:  "+str(G.Player_Punkte[1]),screen)
            if G.Check_Win(b,h)[0]:
                if G.Player_Punkte[0]!=G.Player_Punkte[1]:
                    draw_text("Spieler "+str(G.Check_Win(b,h)[1])+" hat  mit "+str(G.Player_Punkte[G.Check_Win(b,h)[1]-1])+" Punkten gewonnen!",screen, 5,200)
                else:
                    draw_text("Unentschieden",screen,5,200)
                Game_is_running = False
                pygame.display.flip()
                Linien_gruppe.draw(screen)
                print("\nSpiel ist zuende!")

        pygame.display.flip()

        Linien_gruppe.draw(screen)
        Feld_gruppe.draw(screen)
        clock.tick(60)
    print("Spiel ist zuende")
    pygame.display.flip()
    Linien_gruppe.draw(screen)
    Feld_gruppe.draw(screen)
    time.sleep(5)
    pygame.quit()
    return




##### KI part

import threading
import time

import pickle

# Klasse der Threads
class myThread_KI(threading.Thread):
    def __init__(self, threadId, name, population, n=10):#, count):
        threading.Thread.__init__(self)
        self.threadId = threadId
        self.name = name
        self.con = threading.Condition()
        self.ist_fertig = True
        self.running = True
        self.i = 0
        self.p = population
        self.n = n-1


    def run(self):
        self.ist_fertig = True
        self.con.acquire()
        self.con.wait()
        self.con.release()

        time.sleep(1)

        if self.threadId == 1:
            self.p.run(KI_1,self.n)

        if self.threadId == 2:
            self.p.run(KI_2,self.n)

        self.ist_fertig = True

        self.running = False

#ermöglicht kommunikation zwichen der Threads i.e. den KI`s
def my_notify(thread):
    if thread.ist_fertig:
        if thread.running:
            thread.ist_fertig = False
            thread.con.acquire()
            thread.con.notify()
            thread.con.release()
            while not thread.ist_fertig:
                time.sleep(0.1)
                if not thread.running:
                    break


# implementirt Genomes und Nets/ Ermittelt beste KI
def main_controller(thread_1,thread_2,n, b=4, h=4):

    global GENOMES_1
    global GENOMES_2

    global NETS_1
    global NETS_2

    global GEN

    maincounter = 0

    time.sleep(1)

    my_notify(thread_1)
    my_notify(thread_2)

    for i in range (n):

        GEN += 1

        for i in range(len(GENOMES_1)):
            for j in range(len(GENOMES_2)):
                ge = [GENOMES_1[i], GENOMES_2[j]]
                nets = [NETS_1[i], NETS_2[j]]

                Main_mit_KI(b,h, ge, nets)

        my_notify(thread_1)
        my_notify(thread_2)


    thread_1.running = False
    thread_2.running = False

    global Start_time
    End_time = time.perf_counter()


    Index_best_1 = [x.fitness for x in GENOMES_1].index(max([x.fitness for x in GENOMES_1]))
    Index_best_2 = [x.fitness for x in GENOMES_2].index(max([x.fitness for x in GENOMES_2]))
    print(Index_best_1)
    print("fitness: ", GENOMES_1[Index_best_1].fitness)

    Fittest_Individual_1 = NETS_1[Index_best_1]
    Fittest_Individual_2 = NETS_2[Index_best_2]

    if GENOMES_1[Index_best_1].fitness >= GENOMES_2[Index_best_2].fitness:
        Best_Individual = Fittest_Individual_1
    else:
        Best_Individual = Fittest_Individual_2
    print(Fittest_Individual_1)

    KI_file_name = Name_time("KI_1_n" + str(n))
    print(KI_file_name)
    with open(os.path.join(local_dir, KI_file_name + '.pkl'), 'wb') as outfile:
        pickle.dump(Best_Individual, outfile)
    print("KI 1 wurde mit folgendem Namen gespeichert: ", KI_file_name)

    Main_Spieler_gegen_KI(b, h, Best_Individual)


# wandelt 2D liste zu 1D liste um, um diese an die NEAT funktion zu übergeben
def liste_2D_zu_1D(Liste):
    neue_liste =[]
    for i in range(len(Liste)):
        for j in range(len(Liste[i])):
            neue_liste.append(Liste[i][j])
    return neue_liste

# wandelt 1D liste zu 2D liste um, um diese verstänlicher ausgeben zu können
def Koordinaten_berechnen(b,h,Index):
    counter = 0
    for i in range(2*h + 1):
        for j in range(b + 1):
            if i % 2 == 0:
                if j < b:
                    counter += 1
            else:
                counter += 1
            if counter == Index:
                Koordinaten = [j,i]
                return Koordinaten



import neat
import os
GEN = 0

GENOMES_1 = []
GENOMES_2 = []

NETS_1 = []
NETS_2 = []


# lässt die KI`s gegeneinander spielen
def Main_mit_KI(b,h, ge, nets, width = 1280,height = 720,Edges_not_playable=False, Grafik=False):


    G=Game_Object()
    BG_Gruppe=pygame.sprite.Group()
    BG=Init_Felder(0,0,1,1,170,170,BG_Gruppe)

    Linien_gruppe= pygame.sprite.Group()
    Feld_gruppe= pygame.sprite.Group()
    pygame.init()
    clock = pygame.time.Clock()

    if Grafik:
        screen = pygame .display. set_mode((width,height))
    Init_Spiel(100,100,b,h,10,100,Linien_gruppe,Feld_gruppe)
    Dict=Init_Dict(b,h)
    if Edges_not_playable:
        Disable_Edges(b,h,Linien_gruppe)
    G.Init_Data(b,h)

    Spiel_am_laufen = True
    while Spiel_am_laufen:

        Spielfeld = tuple(liste_2D_zu_1D(G.Data))

        Output = nets[G.Player].activate(Spielfeld)#funktion für eingabe der KI usw...

        #Abfrage um zu Prüfen, ob der eingegebene zug möglich ist
        #sollte dierekt in die KI

        for i in range(len(Output)):
            if Spielfeld[i]==1:
                Output[i]=-10000

        Eingabe_index = Output.index(max(Output)) + 1
        Eingabe = Koordinaten_berechnen(b,h,Eingabe_index)


        Linie = Get_Linie(Linien_gruppe, Eingabe)

        if Linie.Set:
            ge[G.Player].fitness -= 10000
            print("---Ende nach " + str(G.Counter) + " Zügen.")
            print("KI " + str(G.Player) + " hat ein falsches Feld gewählt")
            print("Die Eingabe war: " , Eingabe, ", Index: ", Eingabe_index, ", Wert: ", max(Output))
            print(G.Data)
            print(Output)
            time.sleep(10)
            return G.Counter

        #ge[G.Player].fitness += 20
        G.Set_Linie(Linie.Nummer, Dict, Linien_gruppe,Feld_gruppe)
        G.Count_up()
        Linie.Update()
        G.Update_Data(Linie)


        #kann weg

        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            if Grafik:
                if event.type == pygame.MOUSEBUTTONDOWN:
                    mouse_pos=pygame.mouse.get_pos()
                    for Linie in Linien_gruppe:
                        if Linie.rect.collidepoint(mouse_pos):
                            print(Linie.Nummer)
                            Dict_get(Dict, Linie.Nummer)
                            if not Linie.Set:
                                Linie.Color=G.Player_color[G.Player]
                                G.Set_Linie(Linie.Nummer, Dict, Linien_gruppe,Feld_gruppe)
                                G.Count_up()
                                Linie.Update()
                                G.Update_Data(Linie)
                                print ('yay!')
                    for Feld in Feld_gruppe:
                        if Feld.rect.collidepoint(mouse_pos):
                            print(Feld.Nummer)


            if G.has_changed:

                print("Spieler 1:  "+str(G.Player_Punkte[0])+"\n"+"Spieler 2:  "+str(G.Player_Punkte[1]))
                G.has_changed=False
                if Grafik:
                    BG_Gruppe.draw(screen)
                    draw_text("Spieler 1:  "+str(G.Player_Punkte[0])+"\n"+"Spieler 2:  "+str(G.Player_Punkte[1]),screen)
                    if G.Check_Win(b,h)[0]:
                        if G.Player_Punkte[0]!=G.Player_Punkte[1]:
                            draw_text("Spieler "+str(G.Check_Win(b,h)[1])+" hat  mit "+str(G.Player_Punkte[G.Check_Win(b,h)[1]-1])+" Punkten gewonnen!",screen, 5,200)
                        else:
                            draw_text("Unentschieden",screen,5,200)
            if Grafik:
                pygame.display.flip()
                Linien_gruppe.draw(screen)
                Feld_gruppe.draw(screen)
                clock.tick(60)


        if G.Check_Win(b,h)[0]:
            ge[G.Check_Win(b,h)[1]-1].fitness += 20 * G.Player_Punkte[G.Check_Win(b,h)[1]-1 ]
            ge[G.Check_Win(b,h)[1]-2].fitness -= 20 * G.Player_Punkte[G.Check_Win(b,h)[1]-1]
            return G.Counter

# legt die fitness für die KI 1 fest
def KI_1(genomes, config):
    global GENOMES_1
    global NETS_1

    nets = []
    ge = []

    for _,g in genomes:
        net = neat.nn.FeedForwardNetwork.create(g, config)
        nets.append(net)
        g.fitness = 0
        ge.append(g)

    GENOMES_1 = ge
    NETS_1 = nets

    thread_KI_1.ist_fertig = True

    thread_KI_1.con.acquire()
    thread_KI_1.con.wait()
    thread_KI_1.con.release()

# legt die fitness für die KI 2 fest
def KI_2(genomes, config):
    global GENOMES_2
    global NETS_2

    nets = []
    ge = []

    for _,g in genomes:
        net = neat.nn.FeedForwardNetwork.create(g, config)
        nets.append(net)
        g.fitness = 0
        ge.append(g)

    GENOMES_2 = ge
    NETS_2 = nets

    thread_KI_2.ist_fertig = True

    thread_KI_2.con.acquire()
    thread_KI_2.con.wait()
    thread_KI_2.con.release()


#ruft die an die KI angpasste my_thread funktion auf

def start_NeuralNetwork(config_path):
    config = neat.config.Config(neat.DefaultGenome, neat.DefaultReproduction,
                                neat.DefaultSpeciesSet, neat.DefaultStagnation,
                                config_path)
    p = neat.Population(config)

    p.add_reporter(neat.StdOutReporter(True))
    stats = neat.StatisticsReporter()
    p.add_reporter(stats)
    return p

# NEAT funktion über welche das Programm laufen muss
def run(n):

    global GENOMES_1
    global GENOMES_2

    global NETS_1
    global NETS_2

    #Ki und game thread werden gestartet
    thread_KI_1.start()
    thread_KI_2.start()

    main_controller(thread_KI_1,thread_KI_2,n)


#Starting the Program
if __name__ == "__main__":

    Start_time = time.perf_counter()

    n = 3

    pygame.init()

    local_dir = os.path.dirname(__file__)
    config_path = os.path.join(local_dir, "config-feedforward.txt")

    thread_KI_1 = myThread_KI(1, "Thread KI 1", start_NeuralNetwork(config_path), n)
    thread_KI_2 = myThread_KI(2, "Thread KI 2", start_NeuralNetwork(config_path), n)

    run(n)
    print("Das Programm ist fertig.")
